//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef _LTYPE_H
#define _LTYPE_H

//These enum values must be less than TYPEWIDTH; they have to be extractable
//from the attribute's constant, taking the remainder of the division by
//TYPEWIDTH: every attribute is in fact composed by the value (divisible by
//TYPEWIDTH) plus the type.

//There must _not_ be a type with zero value: a zero type component is
//considered to be an error, and this can very useful for debugging.

#define TYPEWIDTH 8 // it's better if this is a two power

#include "LEvent.h"

// The internal rapresentation of a LName is an integer number
typedef int LName;

class LWidget; // This is needed for LCallBack type definition

// A callback is a procedure having a reference to a widget as parameter:
// when called by LTakeshi, the reference 'points' to the widget itself.
typedef void(*LCallBack)(LWidget &itself,const LEvent);

enum LType{LTUndefined=0,    // This is used to recognize errors
           LTInt=1,          // int attribute
           LTDouble=2,       // double attribute
           LTString=3,       // Lstring attribute
           LTBool=4,         // bool attribute
           LTPointer=5,      // void* attribute
           LTCallBack=6,     // LCallBack attribute
           LTSpecial=7};     // Reserved for future use

#endif //#ifndef _LTYPE_H







