//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LWINDOW_H_
#define LWINDOW_H_

#include "LWidget.h"
#include "LContainer.h"
#include "sysdep/LWindow.h"

class LWindow:public LContainer{
// If this platform needs some 'friend' declarations, the preprocessor
// will put them here
#ifdef PLATFORM_DEPENDANT_LWINDOW_FRIENDS
  PLATFORM_DEPENDANT_LWINDOW_FRIENDS
#endif
public:                            // To do: this would better be private
  // System-dependant field
  SysDepWindowData SysDepAsWindow; // Definition is in ./sysdep/LWindow.h;
                                   // This structure contains only the fields
                                   // that an LContainer hasn't; the shared
                                   // ones are in SysDep.
protected:
  // System-dependant methods
  virtual void Apply();            // Commits changes and resets modification
                                   // flags; the definition is in
                                   // ./sysdep/LWindow.cc, because
                                   // this method is platform-dependant

  virtual void SystemDependantInit();
                                   // Called in the constructor, defined in
                                   // ./sysdep/LWindow.cc

  virtual void SystemDependantDone();
                                   // Called in the destructor, defined in
                                   // ./sysdep/LWindow.cc
public:
  // Constructor and Destructor
  LWindow();
  ~LWindow();

  // virtual void LWindow::Show() and LWindow::Hide() methods
  virtual void Show();             // Defined in ./sysdep/LWindow.cc
  virtual void Hide();             // Defined in ./sysdep/LWindow.cc
};

#endif//#ifndef LWINDOW_H_



