//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef LCANVAS_H_X11_
#define LCANVAS_H_X11_
// X11 version

extern "C"{
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
}

#include "../../LPixmap.h"

struct SysDepCanvasData{
  // The area widget, an Xt/Athena form, is a member of the
  // SysDepContainerData structure.
  
  Widget stupid;    // An Athena widget used to force the widht/height to
                    // keep the values I want; without this Athena messes
                    // up the size at every resize. See also my LWindow
                    // implementation, which uses the same trick.
                    // [To do: this works, but is a dirty hack]
                    
  int distance;     // used to store the SysDep.widget defaultDistance
                    // resource, useful to place stupid.
                    
//  GC GraphicContext;// The graphic context used to draw in the area.
};

// Friend functions declaration and implementation-defined fields, to be
// included in class header:
#define PLATFORM_DEPENDANT_LCANVAS_FIELDS                                   \
friend void LCanvasRedrawCanvas(Widget w,XEvent *e,String *s,Cardinal *c);  \
friend class LPixmap;                                                       \
LPixmap CanvasPixmap; // The currently displayed image. It's used when
                      // re-drawing is necessary, after an X Expose event.

#endif //#ifdef LCANVAS_H_X11_

