#ifndef _LBUFFER_H
#define _LBUFFER_H

#include "Lgen/Lgen.h"
#include <iostream.h>

template <class T> class Lbuffer{
 T *buffer;
 INDEX dim;
public:
 Lbuffer(INDEX n=0);
 Lbuffer(Lbuffer&);
 ~Lbuffer();
 inline INDEX getdim();
 void setdim(INDEX);             //this should be made faster...
 inline T& operator[](INDEX);
 int insert(INDEX);
 int insert(INDEX,T);
 friend ostream& operator<< <> (ostream&,Lbuffer);
};

template <class T> int Larray<T>::insert(INDEX n)
{
 INDEX ct;

 if(n>getdim())
  return(-1);//Error: wrong n
 setdim(getdim()+1);
 for(ct=getdim()-1;ct>n;ct--)
  p[ct]=p[ct-1];
 p[n]=new(T);
 return(0);//OK
}

template <class T> int Larray<T>::insert(INDEX n, T t)
{
 int r=insert(n);
 if(!r)
  operator[](n)=t;
 return(r);
}

template <class T> Lbuffer<T>::Lbuffer(INDEX n){
 dim=0;
 buffer=0;
 if(n!=0)
   setdim(n);
}

template <class T> Lbuffer<T>::Lbuffer(Lbuffer &b){
 dim=b.dim;
 buffer=new T[dim];
 INDEX ct;
 for(ct=0;ct<dim;ct++)
  operator[](ct)=b[ct];
}

template <class T> Lbuffer<T>::~Lbuffer(){
 delete[]buffer;
}

template <class T> INDEX Lbuffer<T>::getdim(){
 return dim;
}

template <class T> void Lbuffer<T>::setdim(INDEX x){
 if((x==dim)||(x<0))
  return;
 else if(x>dim){
  INDEX ct;
  T *newbuffer=new T[x];
  for(ct=0;ct<dim;ct++)
   newbuffer[ct]=buffer[ct];
  delete[]buffer;
  buffer=newbuffer;
 }
 else{//x<dim
  INDEX ct;
  T *newbuffer=new T[x];
  for(ct=0;ct<x;ct++)
   newbuffer[ct]=buffer[ct];
  delete[]buffer;
  buffer=newbuffer;
 }
 dim=x;
 return;
}

template <class T> T& Lbuffer<T>::operator[](INDEX x){
 if(x<0)
  fatal("buffer<T>: element out of range");
 else if(x>=dim)
  setdim(x+1);
 return buffer[x];
}

template <class T> ostream& operator<<(ostream& s,Lbuffer<T> b){
 s<<"#(";
 INDEX ct;
 for(ct=0;ct<b.dim;ct++){
  s<<b[ct];
  if(ct<b.dim-1)
   s<<' ';
 }
 s<<')';
 return s;
}

#endif

