#include "Lgen.h"
#include "errno.h"

#include <sys/time.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>

#include "../Lstring/Lstring.h"

float _TEMP_FLOAT_,_TEMP_FLOAT_1,_TEMP_FLOAT_2,_TEMP_FLOAT_3;

void fatal(const Lstring s){
  fatal(s.ToCharStar());
}

void fatal(const char* s){
 cerr<<"\nFatal error:\n"<<s<<"\nProgram aborted.\n";
 cerr<<"\nError "<<errno<<": ";
 perror("");
 cerr<<"\n\n";
 exit(EXIT_FAILURE);
}

void* xmalloc(size_t size){
 register void *value=malloc(size);
 if(!value){
  fatal("xmalloc: virtual memory exausted");
  return 0;//just to avoid warnings from GCC --pedantic
 }else
  return(value);
}

void* xrealloc(void *ptr,size_t size){
 register void *value;
 if(ptr!=0)
   value=realloc(ptr,size);
 else
   value=malloc(size);
 if(!value){
  fatal("xrealloc: virtual memory exausted");
  return 0;//just to avoid warnings from GCC --pedantic
 }else
  return(value);
}

LException::LException(){
  //cerr<<"LException::LException()\n";
}

LException::LException(const LException&){
  //cerr<<"LException::LException(LException&)\n";
}

LException::~LException(){
  //cerr<<"LException::~LException()\n";
}

bool FileExists(const Lstring s){
  FILE *f=fopen(s.ToCharStar(),"r");
  if(f==0)
    return false;
  else{
    fclose(f);
    return true;
  }
}

